-- CTF Hud

---@param p player_t
---@param cam camera_t
hud.add(function(v, p, cam)
    hud.disable("teamscores")

    --Only do this in CTF
    if gametype ~= 7 then return end

    --Draw the flag icons.
    local rflagpic = v.cachePatch("RFLAGICO")
    local bflagpic = v.cachePatch("BFLAGICO")
    v.drawScaled(258*FRACUNIT, 176*FRACUNIT, FRACUNIT/2, rflagpic, V_SNAPTOBOTTOM|V_SNAPTORIGHT)
    v.drawScaled(289*FRACUNIT, 176*FRACUNIT, FRACUNIT/2, bflagpic, V_SNAPTOBOTTOM|V_SNAPTORIGHT)

    --Draw NONICON when the flag is taken
    local taken = v.cachePatch("NONICON")
    if redflag == nil then v.draw(258, 172, taken, V_SNAPTOBOTTOM|V_SNAPTORIGHT) end
    if blueflag == nil then v.draw(289, 172, taken, V_SNAPTOBOTTOM|V_SNAPTORIGHT) end

    --Draw the flag timer, which is in mobj.fuse
    if redflag ~= nil and redflag.fuse ~= 0 then
        v.drawString(269, 184, tostring(redflag.fuse/TICRATE), V_YELLOWMAP|V_SNAPTOBOTTOM|V_SNAPTORIGHT, "center")
    end
    if blueflag ~= nil and blueflag.fuse ~= 0 then
        v.drawString(300, 184, tostring(blueflag.fuse/TICRATE), V_YELLOWMAP|V_SNAPTOBOTTOM|V_SNAPTORIGHT, "center")
    end
end, "game")

--tab menu hack
hud.add(function(v)
    hud.enable("teamscores")
end, "scores")